<template>
  <div class="footer">
    <div class="footer__top">
      <div class="footer__row">
        <div class="footer__left">
          <div v-if="menuItems">
            <div class="footer__title">About</div>
            <div class="footer__nav">
              <ul>
                <li v-for="(item, index) in menuItems" :key="index">
                  <a :href="item.url" target="_blank" v-if="item.external">{{
                    getMenuTitle(item)
                  }}</a>
                  <nuxt-link :to="localePath(item.url)" v-else>{{
                    getMenuTitle(item)
                  }}</nuxt-link>
                </li>
              </ul>
            </div>
          </div>
          <div v-if="socialMenuItems">
            <div class="footer__title">Follow</div>
            <div class="footer__nav">
              <ul>
                <li v-for="(item, index) in socialMenuItems" :key="index">
                  <a :href="item.url" target="_blank" v-if="item.external">{{
                    getMenuTitle(item)
                  }}</a>
                  <nuxt-link :to="localePath(item.url)" v-else>{{
                    getMenuTitle(item)
                  }}</nuxt-link>
                </li>
              </ul>
            </div>
          </div>
        </div>
        <div class="footer__right">
          <div class="footer__title">{{ $t('footer.accept') }}</div>
          <div class="footer__partners">
            <div>
              <img src="~/assets/images/logotype/visa.svg" alt="" />
            </div>
            <div>
              <img
                src="~/assets/images/logotype/mastercard-seeklogo.com.svg"
                alt=""
              />
            </div>
            <div>
              <img src="~/assets/images/logotype/logo-mir.png" alt="" />
            </div>
          </div>
          <div class="footer__terms">
            <nuxt-link :to="localePath('/about#terms-of-usage')">{{
              $t('footer.terms')
            }}</nuxt-link>
          </div>
          <div class="hide-desktop">
            <div class="footer__lang">
              <LangSwitch />
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="footer__bottom">
      <div class="footer__row align-center">
        <div class="footer__left">
          <div class="footer__copyright">
            <svg-icon name="logotype-small" />
            <span>{{ year }} {{ $t('footer.copyright') }}</span>
          </div>
        </div>
        <div class="footer__right hide-mobile">
          <LangSwitch />
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, useAsync, computed } from '@nuxtjs/composition-api'
import LangSwitch from '@/components/app/LangSwitch.vue'
import { Menu_Type_Enum, MenuItemWithLocalizationFragment } from '@/sdk/types'
import useGetLocales from '@/hooks/get-locales'
import getMenuTitle from '@/hooks/get-menu-title'
import { AppEvents } from '~/types'
import { useGetMenuItemsQuery } from '~/sdk/hooks'
import { format } from 'date-fns'

export default defineComponent({
  name: 'AppFooter',
  components: {
    LangSwitch
  },
  setup(_, { root }) {
    const { onResult, refetch } = useGetMenuItemsQuery({
      types: [Menu_Type_Enum.Footer, Menu_Type_Enum.SidebarSocial],
      locales: useGetLocales(root.$i18n)
    })

    const menu = useAsync<MenuItemWithLocalizationFragment[]>(
      () =>
        new Promise(resolve =>
          onResult(result => {
            resolve(result?.data?.menu ?? [])
          })
        )
    )

    if (process.client) {
      root.$on(AppEvents.LocaleChanged, () => {
        refetch({
          types: [Menu_Type_Enum.Footer, Menu_Type_Enum.SidebarSocial],
          locales: useGetLocales(root.$i18n)
        })
      })

      onResult(result => {
        menu.value = result?.data?.menu ?? []
      })
    }

    const menuItems = computed(() =>
      (menu.value || []).filter(i => i.type === Menu_Type_Enum.Footer)
    )

    const socialMenuItems = computed(() =>
      (menu.value || []).filter(i => i.type === Menu_Type_Enum.SidebarSocial)
    )

    const year = format(new Date(), 'yyyy')

    return {
      menuItems,
      socialMenuItems,
      getMenuTitle,
      year
    }
  }
})
</script>

<style lang="scss">
.footer {
  padding-top: 60px;
  padding-bottom: 60px;
  font-size: 0;
  overflow: hidden;
  @media (min-width: 1199.98px) {
    padding-top: 100px;
    padding-bottom: 60px;
  }

  &__top {
    margin-bottom: 80px;
    @media (min-width: 1199.98px) {
      margin-bottom: 140px;
    }
  }

  &__row {
    display: grid;
    grid-template-columns: auto;
    grid-gap: 70px;
    &.align-center {
      align-items: center;
    }

    @media (min-width: 1199.98px) {
      grid-template-columns: 1fr 1fr;
      grid-gap: 50px;
    }
    @media (min-width: 1400px) {
      grid-template-columns: auto 500px;
      grid-gap: 200px;
    }
  }

  &__left {
    display: flex;
    > div {
      flex: 0 0 50%;
    }
  }

  &__title {
    letter-spacing: 2.4px;
    color: #ffffff;
    font-size: 24px;
    line-height: 33px;
    text-transform: uppercase;
    font-weight: 600;
    margin-bottom: 35px;
  }

  &__nav {
    ul {
      margin: 0;
      padding: 0;
      list-style: none;
      display: grid;
      grid-template-columns: repeat(auto-fit, minmax(190px, 1fr));
      grid-gap: 16px 25px;

      li {
        a {
          font-size: 24px;
          line-height: 24px;
          letter-spacing: 0px;
          color: #9badd6;
          text-decoration: none;
          background-image: linear-gradient(
            0deg,
            currentColor 100%,
            rgba(32, 126, 150, 0)
          );
          background-size: 0 1px;
          padding-bottom: 2px;
          background-position: 200% 100%;
          background-repeat: no-repeat;
          transform-origin: left bottom;
          transition: background-size 0.5s ease,
            background-position 0.6s ease-out 0.1s, color 0.5s ease;
          &:hover {
            background-size: 100% 1px;
            background-position: 0 100%;
            animation: underline-hover forwards;
            animation-duration: 0.3s;
          }
        }
      }
    }
  }

  &__accept {
    font-size: 24px;
    line-height: 24px;
    letter-spacing: 2.4px;
    color: #ffffff;
    text-transform: uppercase;
    margin-bottom: 20px;
    @media (min-width: 1199.98px) {
      margin-bottom: 20px;
    }
  }

  &__partners {
    margin-bottom: 65px;
    margin: 15px 0 25px 0;
    display: grid;
    grid-template-columns: repeat(auto-fit, minmax(min-content, 140px));
    align-items: center;
    justify-items: center;
    grid-column-gap: 20px;
    grid-row-gap: 25px;

    img {
      max-width: 140px;
    }
  }

  &__terms {
    font-size: 24px;
    line-height: 24px;
    letter-spacing: 0px;
    color: #9badd6;
    margin-top: 70px;

    @media (min-width: 1199.98px) {
      margin-top: 10px;
    }

    a {
      color: inherit;
      text-decoration: none;
      background-image: linear-gradient(
        0deg,
        currentColor 100%,
        rgba(32, 126, 150, 0)
      );
      background-size: 0 1px;
      padding-bottom: 2px;
      background-position: 200% 100%;
      background-repeat: no-repeat;
      transform-origin: left bottom;
      transition: background-size 0.5s ease,
        background-position 0.6s ease-out 0.1s, color 0.5s ease;
      &:hover {
        background-size: 100% 1px;
        background-position: 0 100%;
        animation: underline-hover forwards;
        animation-duration: 0.3s;
      }
    }
  }

  &__lang {
    margin-top: 15px;
  }

  &__copyright {
    font-size: 0;
    flex: 1 !important;
    svg {
      flex: none;
      width: 65px;
      height: 65px;
      fill: #7784ac;
      margin-bottom: 20px;
    }

    span {
      font-size: 24px;
      line-height: 24px;
      letter-spacing: 0px;
      color: #9badd6;
      display: block;
    }

    @media (min-width: 1199.98px) {
      display: flex;
      align-items: center;
      svg {
        margin-right: 30px;
        margin-bottom: 0px;
      }
    }
  }
}
</style>
